import cv2
import base64

def send_webcam_frame(client, converter):
    try:
        cap = cv2.VideoCapture(0)
        
        if not cap.isOpened():
            raise Exception("No webcam detected")
        
        ret, frame = cap.read()
        cap.release()

        if not ret:
            raise Exception("Failed to capture image from webcam")

        _, buffer = cv2.imencode('.jpg', frame, [cv2.IMWRITE_JPEG_QUALITY, 70])
        webcam_data_base64 = base64.b64encode(buffer).decode("utf-8")

        client.emit('message', converter.encode({"webcam": webcam_data_base64}))

    except Exception as e:
        client.emit('message', converter.encode({"webcam_logger": str(e)}))